﻿using CommunityToolkit.Maui.Alerts;
using CommunityToolkit.Maui.Core;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;

namespace TestProject
{
    /// <summary>
    /// 메인 페이지 뷰 모델
    /// </summary>
    [INotifyPropertyChanged]
    public partial class MainPageViewModel
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 입력 텍스트
        /// </summary>
        [ObservableProperty]
        private string inputText = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainPageViewModel()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainPageViewModel()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 입력 텍스트 변경 전 처리하기 - OnInputTextChanging(value)

        /// <summary>
        /// 입력 텍스트 변경 전 처리하기
        /// </summary>
        /// <param name="value">값</param>
        /* async */ partial void OnInputTextChanging(string value)
        {
            //IToast toast = Toast.Make($"[{DateTime.Now:HH:mm:ss}] 입력 테스트 변경 전 처리합니다.", ToastDuration.Short, 14);
            //
            //await toast.Show();
        }

        #endregion
        #region 입력 텍스트 변경 후 처리하기 - OnInputTextChanged(value)

        /// <summary>
        /// 입력 텍스트 변경 후 처리하기
        /// </summary>
        /// <param name="value">값</param>
        async partial void OnInputTextChanged(string value)
        {
            IToast toast = Toast.Make($"[{DateTime.Now:HH:mm:ss}] 입력 테스트 변경 후 처리합니다.", ToastDuration.Short, 14);

            await toast.Show();
        }

        #endregion

        #region 초기화하기 - Reset()

        /// <summary>
        /// 초기화하기
        /// </summary>
        [RelayCommand]
        private void Reset()
        {
            InputText = string.Empty;
        }

        #endregion
    }
}